//+------------------------------------------------------------------+
//|                                       Heiken Ashi and TK1.mq4    |
//+------------------------------------------------------------------+

#property copyright ""
#property link      "http://www..."


// Heiken Ashi
#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 Blue
#property indicator_color2 Yellow
#property indicator_color3 Blue
#property indicator_color4 Yellow
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 3
#property indicator_width4 3
// SuperTrend
#property indicator_color5 Blue
#property indicator_color6 Yellow
#property indicator_width5 2
#property indicator_width6 2

#property indicator_color7 White
#property indicator_width7 2

#property indicator_color8 White
#property indicator_width8 2

//---- buffers Heiken Ashi
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];

//--- input parameters SuperTrend
extern int Nbr_Periods = 10;
extern double Multiplier = 3.0;
//--- buffers SuperTrend
double TrendUp[];
double TrendDown[];

//---- buffer ATR
double AtrBuffer[];

//---- changeTrend buffer
double changeTrend[];

int changeOfTrend;      //SuperTrend

//----
int ExtCountedBars=0;   // Heiken Ashi
int counted_bars=0;     // ATR
int haBar, atrBar, stBar;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//|------------------------------------------------------------------|
int init()
  {
//---- indicators
   IndicatorBuffers(8);
   
   SetIndexStyle(0,DRAW_HISTOGRAM, 0, 1);
   SetIndexBuffer(0, ExtMapBuffer1);
   SetIndexStyle(1,DRAW_HISTOGRAM, 0, 1);
   SetIndexBuffer(1, ExtMapBuffer2);
   SetIndexStyle(2,DRAW_HISTOGRAM, 0, 3);
   SetIndexBuffer(2, ExtMapBuffer3);
   SetIndexStyle(3,DRAW_HISTOGRAM, 0, 3);
   SetIndexBuffer(3, ExtMapBuffer4);
//----
   SetIndexDrawBegin(0,0);
   SetIndexDrawBegin(1,0);
   SetIndexDrawBegin(2,0);
   SetIndexDrawBegin(3,0);
   
// SuperTrend   
   SetIndexBuffer(4, TrendUp);
   SetIndexStyle(4, DRAW_LINE, STYLE_SOLID, 2);
   SetIndexLabel(4, "*Trend Up*");
   SetIndexBuffer(5, TrendDown);
   SetIndexStyle(5, DRAW_LINE, STYLE_SOLID, 2);
   SetIndexLabel(5, "*Trend Down*");
   
// fr ATR berechnung    
   SetIndexBuffer(6,AtrBuffer);
   SetIndexStyle(6, DRAW_LINE, STYLE_SOLID, 2);
   SetIndexLabel(6, "*ATR*");
   
   SetIndexBuffer(7,changeTrend);   
   SetIndexStyle(7, DRAW_LINE, STYLE_SOLID, 2);
   SetIndexLabel(7, "*changeTrend*");
   
   SetIndexDrawBegin(4,0);
   SetIndexDrawBegin(5,0);
   SetIndexDrawBegin(6,0);
   SetIndexDrawBegin(7,0);
 
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- TODO: add your code here
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   double haOpen, haHigh, haLow, haClose;
   double hOpen[5000],hClose[5000],hHigh[5000],hLow[5000];
   double Atr[5000];
   if(Bars<=10) return(0);
   ExtCountedBars=IndicatorCounted();
   haBar = ExtCountedBars;
//---- check for possible errors
   if (ExtCountedBars<0) return(-1);
//---- last counted bar will be recounted
   if (ExtCountedBars>0) ExtCountedBars--;
   int pos=Bars-ExtCountedBars-1;
//   Alert("pos-HeAsh: "+pos+" "+Bars+" "+ExtCountedBars+" "+haBar);

//----- Heiken Ashi calculation (it is based on standard indicator)
   while(pos>=0)
     {
      haOpen=(ExtMapBuffer3[pos+1]+ExtMapBuffer4[pos+1])/2;
      haClose=(Open[pos]+High[pos]+Low[pos]+Close[pos])/4;
      haHigh=MathMax(High[pos], MathMax(haOpen, haClose));
      haLow=MathMin(Low[pos], MathMin(haOpen, haClose));
      if (haOpen<haClose) 
        {
         ExtMapBuffer1[pos]=haLow;
         ExtMapBuffer2[pos]=haHigh;
        } 
      else
        {
         ExtMapBuffer1[pos]=haHigh;
         ExtMapBuffer2[pos]=haLow;
        } 
      ExtMapBuffer3[pos]=haOpen;
      ExtMapBuffer4[pos]=haClose;

// quasi chart value, it is based on heiken ashi values       
      hClose[pos]=haClose;
      hOpen[pos]=(hOpen[pos+1]+hClose[pos+1])/2;
      hLow[pos]=MathMin(Low[pos], MathMin(hOpen[pos], haClose));
      hHigh[pos]=MathMax(High[pos], MathMax(haOpen, haClose));
      
 	   pos--;
     }
//---- END of Heiken Ashi

//--- ATR calculation (it is based on standard indicator)
   int i;
   double TempBuffer1[5000];
   ArraySetAsSeries(TempBuffer1, false);
   
   counted_bars=IndicatorCounted();
   atrBar = counted_bars;
//----
   if(Bars<=Nbr_Periods) return(0);
//---- initial zero
   if(counted_bars<1)
      for(i=1;i<=Nbr_Periods;i++) AtrBuffer[Bars-i]=0.0;
//----
   if(counted_bars>0) counted_bars--; // siehe oben wie bei Heihen Ashi 
   i=Bars-counted_bars-1;
//   Alert("i-ATR: "+i+" "+Bars+" "+counted_bars+" "+atrBar);
   while(i>=0)
     {
// no chart, but Heiken Ashi value
      double high=hHigh[i];
      double low =hLow[i];
      if(i==Bars-1) TempBuffer1[i]=high-low;
      else
        {
// Heiken Ashi value
         double prevclose=hClose[i+1];
         TempBuffer1[i]=MathMax(high,prevclose)-MathMin(low,prevclose);
        }
      i--;
     }
//----
   if(counted_bars>0) counted_bars--;
   int limit=Bars-counted_bars-2;   // siehe oben die Sub wg. Heiken Ashi
//   Alert("limit-ATR: "+limit+" "+Bars+" "+counted_bars+" "+atrBar);
   for(i=0; i<limit; i++) {
      AtrBuffer[i]= iMAOnArray(TempBuffer1,Bars,Nbr_Periods,0,MODE_SMA,i);
   }
        
//---- END of ATR -------------


//--- SuperTrend calculation
   int flag, flagh, trend[5000];
   double up[5000], dn[5000], medianPrice, atr;
   
   counted_bars = IndicatorCounted();
   stBar = counted_bars;
//---- check for possible errors
   if(counted_bars < 0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars > 0) counted_bars--;
   limit=Bars-counted_bars;
   //Print(limit);
   
//----
//   Alert("Bars: "+Bars+" "+stBar);
   for (i = Bars; i >= 0; i--) {
      TrendUp[i] = EMPTY_VALUE;
      TrendDown[i] = EMPTY_VALUE;
// Heiken Ashi basierend
      atr = AtrBuffer[i];
      //Print("atr: "+atr[i]);
      
// Heikin Ashi
      medianPrice = (heAshi_High(i)+heAshi_Low(i))/2;
      medianPrice = (hHigh[i]+hLow[i])/2;
      //Print("medianPrice: "+medianPrice[i]);
      up[i]=medianPrice+(Multiplier*atr);
      //Print("up: "+up[i]);
      dn[i]=medianPrice-(Multiplier*atr);
      //Print("dn: "+dn[i]);
      trend[i]=1;
   
// Heikin Ashi values
      if (hClose[i]>up[i+1]) {
         trend[i]=1;
         if (trend[i+1] == -1) changeOfTrend = 1;
         //Print("trend: "+trend[i]);
         
      }
// Heikin Ashi values
      else if (hClose[i]<dn[i+1]) {
         trend[i]=-1;
         if (trend[i+1] == 1) changeOfTrend = 1;
         //Print("trend: "+trend[i]);
      }
      else if (trend[i+1]==1) {
         trend[i]=1;
         changeOfTrend = 0;       
      }
      else if (trend[i+1]==-1) {
         trend[i]=-1;
         changeOfTrend = 0;
      }

      if (trend[i]<0 && trend[i+1]>0) {
         flag=1;
         //Print("flag: "+flag);
      }
      else {
         flag=0;
         //Print("flagh: "+flag);
      }
      
      if (trend[i]>0 && trend[i+1]<0) {
         flagh=1;
         //Print("flagh: "+flagh);
      }
      else {
         flagh=0;
         //Print("flagh: "+flagh);
      }
      
      if (trend[i]>0 && dn[i]<dn[i+1])
         dn[i]=dn[i+1];
      
      if (trend[i]<0 && up[i]>up[i+1])
         up[i]=up[i+1];
      
      if (flag==1)
         up[i]=medianPrice+(Multiplier*atr);
         
      if (flagh==1)
         dn[i]=medianPrice-(Multiplier*atr);
         
      changeTrend[i] = 1.40;                 // changeTrend-Buffer for EA application (NOP no opertation)  
      //-- Draw the indicator
      if (trend[i]==1) {
         TrendUp[i]=dn[i];
         if (changeOfTrend == 1) {
            TrendUp[i+1] = TrendDown[i+1];
            changeOfTrend = 0;
            changeTrend[i] = 1.38;            // changeTrend-Buffer for EA application(LONG) 
            Print(TimeToStr(Time[i])+": "+changeTrend[i]+" "+i+" long "+Bars);
         }
      }
      else if (trend[i]==-1) {
         TrendDown[i]=up[i];
         if (changeOfTrend == 1) {
            TrendDown[i+1] = TrendUp[i+1];
            changeOfTrend = 0; 
            changeTrend[i] = 1.42;            // changeTrend-Buffer for EA application (SHORT)
            Print(TimeToStr(Time[i])+" "+changeTrend[i]+" "+i+" short "+Bars);
         }
      }
   }
   WindowRedraw();
      
//---- END of SuperTrend


   return(0);
  }
//+------------------------------------------------------------------+

double heAshi_High (int i) {
      if (ExtMapBuffer3[i]<ExtMapBuffer4[i]) 
         return (ExtMapBuffer2[i]);
      else
         return (ExtMapBuffer1[i]);
}

double heAshi_Low (int i) {
      if (ExtMapBuffer3[i]<ExtMapBuffer4[i]) 
         return (ExtMapBuffer1[i]);
      else
         return (ExtMapBuffer2[i]);
}